% Config document
%===============================================================================
%-------------------------------------------------------------------------------
% General Purpose Packages
%-------------------------------------------------------------------------------
\usepackage[table,dvipsnames]{xcolor}
\usepackage[english]{babel}
\usepackage[utf8]{inputenc}
\usepackage{textcomp}
\usepackage{etoolbox}
\usepackage{graphicx}
\usepackage{float}
\usepackage{subcaption}
\usepackage{caption}
\usepackage{booktabs}
\usepackage{tocvsec2}
\usepackage{tabularx}
\usepackage{multicol}
\usepackage{pdfpages}
\usepackage{appendix}
\usepackage{pgffor}
\usepackage{pdflscape}
\usepackage{csvsimple}
\usepackage{awesomebox}

%-------------------------------------------------------------------------------
% Math Packages
%-------------------------------------------------------------------------------
\usepackage[utopia]{mathdesign}     % Math font
\usepackage{physics}                % Math notations for physics
\usepackage{siunitx}				% Si units
\usepackage{exscale}				% mathematical size corresponds to textsize
\usepackage{textcomp,gensymb}       % additional text symbols
\usepackage{wasysym}
\usepackage{bbm}                    % mathbb for numbers
\usepackage{trfsigns}               % Fourier and Lapalce symbols
\usepackage{cancel}                 % fix neq symbol

%-------------------------------------------------------------------------------
% Graphics
%-------------------------------------------------------------------------------
\usepackage{tikz}
\usepackage{enumitem}
\usepackage[european]{circuitikz}
\usepackage[export]{adjustbox}
\usepackage{subfiles}
\usepackage{wrapfig}
\usepackage{overpic}
\graphicspath{{images/},{images/pdf/}}

%-------------------------------------------------------------------------------
% Select Font
%-------------------------------------------------------------------------------
\usepackage[sfdefault, book, scaled=.87]{Fira Sans}
\usepackage[scaled=.87, lining]{FiraMono}
\sisetup{
	detect-mode,
	math-rm=\ensuremath{\mathrm},
}

\raggedbottom % don't  stretch text

%-------------------------------------------------------------------------------
% Colors
%-------------------------------------------------------------------------------
\definecolor{darkblue}{rgb}{0.21,0.33,0.43}     % Dark blue
\definecolor{bfhgrey}{rgb}{0.41,0.49,0.57}      % BFH grey
\definecolor{bfhlight}{rgb}{0.93,0.94,0.95}
\definecolor{linkcolor}{rgb}{0,0,0}
\definecolor{bfhyellow}{rgb}{0.79,0.67,0.19}

\definecolor{blue}{rgb}{0.23,0.49,0.71} % blue
\definecolor{colorAccent1}{rgb}{0.23,0.49,0.71} % blue
\definecolor{colorAccent1Dark}{rgb}{0.09,0.21,0.55}
\definecolor{green}{rgb}{0.29,0.47,0.35} % green
\definecolor{colorAccent2}{rgb}{0.29,0.47,0.35} % green
\definecolor{colorAccent2Dark}{rgb}{0.28,0.46,0.35}
\definecolor{red}{rgb}{0.84,0.23,0.29} % red
\definecolor{colorAccent3}{rgb}{0.84,0.23,0.29} % red
\definecolor{colorAccent3Dark}{rgb}{0.59,0.16,0.20}
\definecolor{purple}{rgb}{0.37,0.26,0.55} % purple
\definecolor{colorAccent4}{rgb}{0.37,0.26,0.55} % purple

\definecolor{colorBackground}{rgb}{0.85,0.85,0.85}

% Grey colored, rounded bar
\newcommand{\bfhbar}[1]{\tikz \draw[rounded corners=0.5mm,color=bfhgrey,fill] (0,0) rectangle (#1,2mm);}

%-------------------------------------------------------------------------------
% Headings
%-------------------------------------------------------------------------------
\makeatletter
\newcommand{\chapterToc}[1] {
	\chapter*{#1}
	\label{#1}
	\addcontentsline{toc}{chapter}{#1}
}
\makeatother

% Reduce excessive spacing
\RedeclareSectionCommand[
	afterskip=1\baselineskip]{chapter}
\RedeclareSectionCommand[
	beforeskip=-\baselineskip,
	afterskip=.25\baselineskip]{section}
\RedeclareSectionCommand[
	beforeskip=-.75\baselineskip,
	afterskip=.25\baselineskip]{subsection}
\RedeclareSectionCommand[
	beforeskip=-.5\baselineskip,
	afterskip=.1\baselineskip]{subsubsection}
\RedeclareSectionCommand[
	beforeskip=.25\baselineskip,
	afterskip=-1em]{paragraph}
\RedeclareSectionCommand[
	beforeskip=-.25\baselineskip,
	afterskip=-1em]{subparagraph}

\addtocontents{toc}{\vspace{-1.5\baselineskip}}

\captionsetup[figure]{
	position=bottom,
	belowskip=-0.5\baselineskip
}

%-------------------------------------------------------------------------------
% Hyperref Package (Create links in a pdf)
%-------------------------------------------------------------------------------
\usepackage[
	pdftex,ngerman,bookmarks=true,plainpages=false,pdfpagelabels,
	backref = {false},					% No index backreference
	colorlinks = {true},                % Color links in a PDF
	hypertexnames = {true},             % no failures "same page(i)"
	pdftitle = {\documenttitle},		% PDF-property
	pdfauthor = {\documentauthor},      % PDF-property
	pdfsubject = {Thesis},       		% PDF-property
	linkcolor = {linkcolor},            % Color of Links
	citecolor = {linkcolor},            % Color of Cite-Links
	urlcolor = {linkcolor}             % Color of URLs
]{hyperref}
\urlstyle{same}
\usepackage[numbered,depth=section]{bookmark}

%-------------------------------------------------------------------------------
% Table of content
% ------------------------------------------------------------------------------
\usepackage{tocloft}

\settocdepth{subsection}

\renewcommand{\cftdotsep}{2}

\renewcommand{\cftchapleader}{\cftdotfill{\cftdotsep}}
\setlength\cftparskip{0.1\baselineskip}
\setlength\cftbeforechapskip{0.1\baselineskip}
\renewcommand\cftchapfont{\normalfont}
\renewcommand\cftsecfont{\normalfont}
\renewcommand\cftchappagefont{\normalfont}
\renewcommand\cftsecpagefont{\normalfont}

\renewcommand\cftfigfont{\normalfont}
\renewcommand\cftfigpagefont{\normalfont}

\renewcommand\cfttabfont{\normalfont}
\renewcommand\cfttabpagefont{\normalfont}

\cftsetindents{figure}{0pt}{1.2cm}
\cftsetindents{table}{0pt}{1.2cm}

%-------------------------------------------------------------------------------
% Makeindex Package
%-------------------------------------------------------------------------------
\usepackage{makeidx}
\makeindex

%-------------------------------------------------------------------------------
% Glossary Package
%-------------------------------------------------------------------------------
%\usepackage[nonumberlist]{glossaries}
%\makeglossaries
%\include{\subfix{database/glossary}}
%\include{\subfix{database/acronyms}}
%\renewcommand*{\glsgroupskip}{}
%\glsaddall

%-------------------------------------------------------------------------------
% Bibliography
%-------------------------------------------------------------------------------
\usepackage{csquotes}
\usepackage[backend=biber, style=ieee]{biblatex}
\addbibresource{database/bibliography.bib}

%-------------------------------------------------------------------------------
% Tables
%-------------------------------------------------------------------------------
\renewcommand{\arraystretch}{1.2}

\newcolumntype{R}[1]{>{\raggedleft\arraybackslash}p{#1}}
\newcolumntype{L}[1]{>{\raggedright\arraybackslash}p{#1}}
\newcolumntype{Y}{>{\raggedright\arraybackslash}X}
\newcolumntype{V}{>{\raggedleft\arraybackslash}X}
\newcolumntype{H}{>{\setbox0=\hbox\bgroup}c<{\egroup}@{}}

\newcommand*\cleartoleftpage{%
  \clearpage
  \ifodd\value{page}\hbox{}\newpage\fi
}

% Multi-page table
% https://tex.stackexchange.com/questions/93808/column-wise-break-of-extra-wide-tables/93810#93810
\def\widesplit#1{%
\cleartoleftpage%
\def\row##1##2{##1}%
#1%
\clearpage
\def\row##1##2{##2}%
#1%
\clearpage
}

% https://tex.stackexchange.com/questions/32683/rotated-column-titles-in-tabular
\newcolumntype{R}[2]{%
    >{\adjustbox{angle=#1,lap=\width-(#2)}\bgroup}%
    l%
    <{\egroup}%
}
\newcommand*\rot{\multicolumn{1}{R{70}{1em}}}% no optional argument here, please!


%-------------------------------------------------------------------------------
% Footnote location
%-------------------------------------------------------------------------------
\setlength{\skip\footins}{1.5cm}

%-------------------------------------------------------------------------------
% Header and Footer
%-------------------------------------------------------------------------------
\usepackage[automark]{scrlayer-scrpage}
\clearpairofpagestyles          % change header and footer for all pages

\newpairofpagestyles{firstpage}{
	\ihead*{}
	\chead*{}
	\ohead*{}
	\ifoot*{\color{bfhgrey}{\organization}}
	\cfoot*{}
	\ofoot*{}
}

\newpairofpagestyles{normalpage}{
	\ihead*{}
	\chead*{}
	\ohead*{}
	\ifoot*{}
	\cfoot*{}
	\ofoot*{\pagemark}
}

\KOMAoption{headsepline}{0pt}   % no line
\addtokomafont{pageheadfoot}{\normalfont\small}
\addtokomafont{pagenumber}{\normalfont\small}

\pagestyle{scrheadings}
\title{\documenttitle}

%-------------------------------------------------------------------------------
% Listings
%-------------------------------------------------------------------------------
\usepackage[newfloat]{minted}
\usemintedstyle{gruvbox-light}
\setminted{
	linenos,
	frame=lines,
	breaklines=true,
	breaksymbolleft=\small\ensuremath{\ \hookrightarrow},
	breaksymbolsepleft=0.8ex,
	autogobble=true,
	fontsize=\small
}
\setmintedinline{breakanywhere,fontsize=\normalsize}

\renewcommand{\theFancyVerbLine}{\sffamily \scriptsize \arabic{FancyVerbLine}}
\SetupFloatingEnvironment{listing}{placement=htp}
\captionsetup[listing]{
	position=bottom,
	skip=-0.5\baselineskip
}

\newcommand{\listingpath}[1]{
	\vspace{1.6em}
	\caption*{%
		\raggedright%
		\small%
		\texttt{\em #1}%
		\vspace{-2.8em}%
}}

% custom listing environment that allows page breaks
\newenvironment{customlisting} {%
	\vspace{-1em}%
	\captionsetup{type=listing}%
} {%
	\vspace{0.3em}%
}%

% referencing lines in a listing
\newcommand*{\verbatimenv}{Verbatim}
\newcommand*{\verbatimotherenv}{internallinenumbers*}
\makeatletter
\newcommand*{\circled}[1]{%
	\ifnum%
		\ifx \verbatimenv \@currenvir%
			1%
		\else \ifx \verbatimotherenv \@currenvir%
			1%
		\else 0 \fi\fi =1%
		\def \circlespace {1.5pt}%
	\else%
		\def \circlespace {0pt}%
	\fi%
	\hspace{\circlespace}%
	%\color{black}
	\tikz[baseline=(char.base)] {%
		\node[%
			shape=circle,%
			draw,fill=white,%
			inner sep=1.2pt,%
			line width=0.6pt%
		]%
		(char) {\firalining#1};%
	}%
	\hspace{\circlespace}%
}%
\makeatother

\makeatletter
\newcommand*{\circledinv}[1]{%
	\ifnum%
		\ifx \verbatimenv \@currenvir%
			1%
		\else \ifx \verbatimotherenv \@currenvir%
			1%
		\else 0 \fi\fi =1%
		\def \circlespace {1.5pt}%
	\else%
		\def \circlespace {0pt}%
	\fi%
	\hspace{\circlespace}%
	\tikz[baseline=(char.base)] {%
		\node[%
			shape=circle,%
			draw,fill,%
			inner sep=1.2pt,%
			line width=0.6pt%
		]%
		(char) {\color{white}\firalining#1};%
	}%
	\hspace{\circlespace}%
}%
\makeatother

%-------------------------------------------------------------------------------
% Additional Units
%-------------------------------------------------------------------------------
\DeclareSIUnit{\belmilliwatt}{Bm}
\DeclareSIUnit{\belmicrovolt}{B\textmu}
\DeclareSIUnit{\belisotropic}{Bi}

%-------------------------------------------------------------------------------
% Macro \xvec
%-------------------------------------------------------------------------------
\makeatletter
\newlength\xvec@height%
\newlength\xvec@depth%
\newlength\xvec@width%
\newcommand{\xvec}[2][]{%
  \ifmmode%
    \settoheight{\xvec@height}{$#2$}%
    \settodepth{\xvec@depth}{$#2$}%
    \settowidth{\xvec@width}{$#2$}%
  \else%
    \settoheight{\xvec@height}{#2}%
    \settodepth{\xvec@depth}{#2}%
    \settowidth{\xvec@width}{#2}%
  \fi%
  \def\xvec@arg{#1}%
  \def\xvec@dd{:}%
  \def\xvec@d{.}%
  \raisebox{.2ex}{\raisebox{\xvec@height}{\rlap{%
    \kern.05em%  (Because left edge of drawing is at .05em)
    \begin{tikzpicture}[scale=1]
    \pgfsetroundcap
    \draw (.05em,0)--(\xvec@width-.05em,0);
    \draw (\xvec@width-.05em,0)--(\xvec@width-.15em, .075em);
    \draw (\xvec@width-.05em,0)--(\xvec@width-.15em,-.075em);
    \ifx\xvec@arg\xvec@d%
      \fill(\xvec@width*.45,.5ex) circle (.5pt);%
    \else\ifx\xvec@arg\xvec@dd%
      \fill(\xvec@width*.30,.5ex) circle (.5pt);%
      \fill(\xvec@width*.65,.5ex) circle (.5pt);%
    \fi\fi%
    \end{tikzpicture}%
  }}}%
  #2%
}
\makeatother

% --- Override \vec with an invocation of \xvec.
\let\stdvec\vec
\renewcommand{\vec}[1]{\mathbf{#1}}
% --- Define \dvec and \ddvec for dotted and double-dotted vectors.
\newcommand{\dvec}[1]{\xvec[.]{#1}}
\newcommand{\ddvec}[1]{\xvec[:]{#1}}
